/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

#include "extern.h"

int flag_nocore = 0;        /* catches core dumping signal and prints a few things */
int flag_tableshow = 0;     /* shows table at the end of every program unit */
int flag_coredump = 0;      /* core dumps on syserr */
int flag_obsolescent = 0;   /* flags obsolescent features */
int flag_externals = 0;     /* allows names of the form @... */
int flag_standard = 0;      /* give warning of all extensions to the F90 standard */
int flag_nointerfaces = 0;  /* system files with interfaces are not read */
int flag_e = 0;             /* in fixed form accepts lines up to 132 characters long */
int flag_pp = 0;            /* pretty-prints parse tree */
int flag_ko = 0;            /* invokes ko_... functions */
int flag_cubix = 0;         /* translates I/O statements to calls to cubix library */
int flag_77 = 0;            /* gives fatal error for extensions to f77 */
int flag_new = 0;
int flag_ignore_fatal = 0;	/* will keep trying even after fatal errors */
int flag_verbose = 0;       /* prints info about the progressing of the compilation */
int flag_w = 0;
int flag_cmf = 0;			/* input is assumed to be CM Fortran */
int flag_no_intrin = 0;     /* doesn't initialize intrinsics */
int flag_source = 0;        /* put original source in output */

int flag_externals_user = 0;
int flag_w_user = 0;

char *input_filename  = CN;
char *output_filename = CN;

/**/ U_DEFINE_STACK (include_path, char*, 5)

FILE *ofd;

args (argc, argv)  /* parses arguments to f9t */
int argc;
char **argv;
{
	int num_no_flag = 0;

	while (--argc > 0)
		if ((*++argv)[0] == '-') {
			if (!strcmp ("express", *argv+1)) {
				flag_express = 1;
				if (!isdigit ((*(argv+1))[0])) {
					para_NN = 1;
				}
				else {
					para_NN = atoi (*++argv);
					argc--;
				}
			}
			else if (!strcmp ("stdin", *argv+1)) {
				yyin = stdin;
				input_filename = "(stdin)";
			}
			else if (!strcmp ("machine", *argv+1)) {
				mac_set (*(++argv));
				argc--;
			}
			else if (!strcmp ("form", *argv+1)) {
				form_set (*(++argv));
				argc--;
			}
			else if (!strcmp ("include", *argv+1)) {
				U_stack_push_include_path(*(++argv));
				argc--;
			}
			else if (!strcmp ("nocore", *argv+1)) {
				flag_nocore = 1;
			}
			else if (!strcmp ("source", *argv+1)) {
				flag_source = 1;
			}
			else if (!strcmp ("verbose", *argv+1)) {
				flag_verbose = 1;
			}
			else if (!strcmp ("no_intrin", *argv+1)) {
				flag_no_intrin = 1;
			}
			else if (!strcmp ("tableshow", *argv+1)) {
				flag_tableshow = 1;
			}
			else if (!strcmp ("coredump", *argv+1)) {
				flag_coredump = 1;
			}
			else if (!strcmp ("obsolescent", *argv+1)) {
				flag_obsolescent = 1;
			}
			else if (!strcmp ("externals", *argv+1)) {
				flag_externals_user = 1;
			}
			else if (!strcmp ("ignore_fatal", *argv+1)) {
				flag_ignore_fatal = 1;
			}
			else if (!strcmp ("standard", *argv+1)) {
				flag_standard = 1;
			}
			else if (!strcmp ("77", *argv+1)) {
				flag_77 = 1;
			}
			else if (!strcmp ("nointerfaces", *argv+1)) {
				flag_nointerfaces = 1;
			}
			else if (!strcmp ("pp", *argv+1)) {
				flag_pp = 1;
			}
			else if (!strcmp ("ko", *argv+1)) {
				flag_ko = 1;
			}
			else if (!strcmp ("cubix", *argv+1)) {
				flag_cubix = 1;
			}
			else if (!strcmp ("e", *argv+1)) {
				flag_e = 1;
			}
			else if (!strcmp ("cmf", *argv+1)) {
				flag_cmf = 1;
			}
			else if (!strcmp ("w", *argv+1)) {
				flag_w_user = 1;
			}
			else {
				sprintf (serr, "f9t: Unknown option: %s", *argv);
				comerrnl (serr);
				exit (1);
			}
		}
		else {
			switch (num_no_flag++) {
			case 0:
				input_filename = *argv;
				break;
			case 1:
				output_filename = *argv;
				break;
			default:
#ifdef CHECK
				SYSERR;
#endif
				exit (1);
			}
		}

	if (input_filename == CN) {
#ifdef CHECK
		SYSERR;
#endif
		exit (1);
	}

	if (output_filename == CN)
		ofd = stdout;
	else
		ofd = fopen (output_filename, "w");

#ifdef CUBIX
	flag_cubix = 1;
	flag_w_user = 1;
	flag_nointerfaces = 1;
	flag_no_intrin = 1;
#endif
}

int include_path_top_fun ()
{
	return include_path_top;
}

char *include_path_fun (i)
{
	return include_path [i];
}
